#!/usr/bin/env python
from CBDLibrary import *
from CBDDraw import *

class MyCustomBlock(CBD):
	def __init__(self, block_name):
		CBD.__init__(self, block_name, input_ports=["In1", "In2", "In3"], output_ports=["Out1", "Out2"])

class Graph(CBD):
	def __init__(self, block_name):
		CBD.__init__(self, block_name)
		self.addBlock(ConstantBlock(block_name="1", value=float(1)))
		self.addBlock(MyCustomBlock(block_name="Cluster"))
		self.addConnection("1", "Cluster", input_port_name="In1", output_port_name="OUT1")
		self.addConnection("1", "Cluster", input_port_name="In2", output_port_name="OUT1")
		self.addConnection("1", "Cluster", input_port_name="In3", output_port_name="OUT1")

CBD = Graph("CBD")
