#!/usr/bin/env python
from CBDLibrary import *
from CBDDraw import *

class Counter(CBD):
	def __init__(self, block_name):
		CBD.__init__(self, block_name, input_ports=[], output_ports=["OutCounterD"])
		self.addBlock(DelayBlock(block_name="delay"))
		self.addBlock(ConstantBlock(block_name="1", value=float(0)))
		self.addBlock(ConstantBlock(block_name="0", value=float(0)))
		self.addBlock(AdderBlock(block_name="sum"))
		self.addConnection("1", "sum", input_port_name="IN2", output_port_name="OUT1")
		self.addConnection("sum", "delay", input_port_name="IN1", output_port_name="OUT1")
		self.addConnection("0", "delay", input_port_name="IC", output_port_name="OUT1")
		self.addConnection("delay", "sum", input_port_name="IN1", output_port_name="OUT1")
		self.addConnection("delay", "OutCounterD", output_port_name="OUT1")

class Graph(CBD):
	def __init__(self, block_name):
		CBD.__init__(self, block_name)
		self.addBlock(Counter(block_name="counter"))
		self.addBlock(ProductBlock(block_name="multiply"))
		self.addBlock(ConstantBlock(block_name="2", value=float(0)))
		self.addConnection("counter", "multiply", input_port_name="IN1", output_port_name="OutCounterD")
		self.addConnection("2", "multiply", input_port_name="IN2", output_port_name="OUT1")

CBD = Graph("CBD")
